# Resume dunning for invoice

> For the complete machine-readable documentation index, see [llms.txt](https://apidocs.chargebee.com/llms.txt).


[Idempotency Supported](/docs/api/idempotency)

Immediately resumes [dunning](https://www.chargebee.com/docs/payments/2.0/dunning-v2.html) for the specified invoice.

-   If the current time is within the dunning period for the invoice, Chargebee resumes any dunning [retries](https://www.chargebee.com/docs/payments/2.0/dunning-v2.html) and [email notifications](https://www.chargebee.com/docs/payments/2.0/dunning-v2.html#dunning-email-notifications) that remain after the pause period, and not attempt the retries or notifications that were canceled during the pause period.
-   If the current time is after the dunning period for the invoice, the [final action](https://www.chargebee.com/docs/payments/2.0/dunning-v2.html) configured in Billing is initiated for the invoice and, if applicable, for the subscription.

#### Prerequisites[](#prerequisites)

This operation is only permitted for an invoice with a [status](/docs/api/invoices/invoice-object#status) of `payment_due` and for which dunning was previously [paused](/docs/api/invoices/pause-dunning-for-invoice).

## Sample Request

#### cURL

```bash
curl  https://{site}.chargebee.com/api/v2/invoices/__demo_inv__4/resume_dunning \
     -X POST  \
     -u {site_api_key}:
```

#### .NET

```dotnet
using ChargeBee.Api;
using ChargeBee.Models;

ApiConfig.Configure("{site}","{site_api_key}");
EntityResult result = Invoice.ResumeDunning("__demo_inv__4").Request();

Invoice invoice = result.Invoice;
```

#### Go

```go
package main
import (
    "fmt"
    "github.com/chargebee/chargebee-go/v3"
    invoiceAction "github.com/chargebee/chargebee-go/v3/actions/invoice"
)
func main() {
    chargebee.Configure("{site_api_key}","{site}");
    res,err := invoiceAction.ResumeDunning("__demo_inv__4", nil).Request()
    if err != nil {
        fmt.Println(err)
    } else {
        Invoice := res.Invoice
    }
}
```

#### Go

```go
package main

import (
  "fmt"
  "github.com/chargebee/chargebee-go/v4"
)

func main() {
  config := &chargebee.ClientConfig{
    SiteName: "{site}",
    ApiKey: "{site_api_key}",
  }    
  client := chargebee.NewClient(config)
  req := &chargebee.InvoiceResumeDunningRequest{}
  res, err := client.Invoice.ResumeDunning("__demo_inv__4", req)
      if err != nil {
        fmt.Println(err)
    } else {
        Invoice := res.Invoice
    }
}
```

#### Java

```java
import com.chargebee.*;
import com.chargebee.ListResult;
import com.chargebee.models.*;
import com.chargebee.models.enums.*;
import java.io.IOException;

public class Sample {

    public static void main(String args[]) throws IOException, Exception {
        Environment.configure("{site}", "{site_api_key}");
        Result result = Invoice.resumeDunning("__demo_inv__4").request();

        Invoice invoice = result.invoice();
    }
}
```

#### Java

```java
import com.chargebee.v4.client.ChargebeeClient;
import com.chargebee.v4.models.invoice.Invoice;
import com.chargebee.v4.models.invoice.params.InvoiceResumeDunningParams;
import com.chargebee.v4.models.invoice.responses.InvoiceResumeDunningResponse;

public class InvoiceResumeDunning {

    public static void main(String[] args) {
        ChargebeeClient client = ChargebeeClient.builder()
            .apiKey("{site_api_key}")
            .siteName("{site}")
            .build();

        InvoiceResumeDunningResponse response = client.invoices().resumeDunning("__demo_inv__4");

        Invoice invoice = response.getInvoice();
    }
}
```

#### Node.js

```node
import Chargebee from "chargebee";

const chargebee = new Chargebee({
    site: "{site}",
    apiKey: "{site_api_key}",
});

try {
    const result = await chargebee.invoice.resumeDunning("__demo_inv__4");

    console.log(result);
    const invoice = result.invoice;
} catch (err) {
    console.log(err);
}
```

#### PHP

```php
<?php

require __DIR__ . '/vendor/autoload.php';

use Chargebee\ChargebeeClient;

$chargebee = new ChargebeeClient(options: [
    "site" => "{site}",
    "apiKey" => "{site_api_key}",
]);
$result = $chargebee->invoice()->resumeDunning("__demo_inv__4");
$invoice = $result->invoice;
```

#### Python

```python
from chargebee import Chargebee

cb_client = Chargebee(api_key="{site_api_key}", site="{site}")
response = cb_client.Invoice.resume_dunning("__demo_inv__4")
invoice = response.invoice
```

#### Ruby

```ruby
require 'chargebee'

ChargeBee.configure(:site => "{site}",
  :api_key => "{site_api_key}")

result = ChargeBee::Invoice.resume_dunning("__demo_inv__4")

invoice = result.invoice
```

## Sample Response

```json
{
  "invoice": {
    "adjustment_credit_notes": {},
    "amount_adjusted": 0,
    "amount_due": 1000,
    "amount_paid": 0,
    "amount_to_collect": 1000,
    "applied_credits": {},
    "base_currency_code": "USD",
    "billing_address": {
      "first_name": "Rachel",
      "last_name": "Green",
      "object": "billing_address",
      "validation_status": "not_validated"
    },
    "credits_applied": 0,
    "currency_code": "USD",
    "customer_id": "__test__8aspTSOcUcz72s",
    "date": 1612796988,
    "deleted": false,
    "due_date": 1612796988,
    "dunning_attempts": [
      {
        "attempt": 0,
        "created_at": 1612796989,
        "dunning_type": "auto_collect",
        "retry_engine": "chargebee",
        "transaction_id": "txn___test__8aspTSOcUezv3v",
        "txn_amount": 1000,
        "txn_status": "failure"
      },
      {..}
    ],
    "dunning_status": "stopped",
    "exchange_rate": 1,
    "first_invoice": false,
    "has_advance_charges": false,
    "id": "__demo_inv__4",
    "is_gifted": false,
    "issued_credit_notes": {},
    "line_items": [
      {
        "amount": 1000,
        "customer_id": "__test__8aspTSOcUcz72s",
        "date_from": 1612796988,
        "date_to": 1612883388,
        "description": "Basic USD 2",
        "discount_amount": 0,
        "entity_id": "basic-USD2",
        "entity_type": "plan_item_price",
        "id": "li___test__8aspTSOcUex03u",
        "is_taxed": false,
        "item_level_discount_amount": 0,
        "object": "line_item",
        "pricing_model": "per_unit",
        "quantity": 1,
        "subscription_id": "__test__8aspTSOcUcz72s",
        "tax_amount": 0,
        "tax_exempt_reason": "tax_not_configured",
        "unit_amount": 1000
      },
      {..}
    ],
    "linked_orders": {},
    "linked_payments": [
      {
        "applied_amount": 1000,
        "applied_at": 1612796989,
        "txn_amount": 1000,
        "txn_date": 1612796989,
        "txn_id": "txn___test__8aspTSOcUezv3v",
        "txn_status": "failure"
      },
      {..}
    ],
    "net_term_days": 0,
    "object": "invoice",
    "price_type": "tax_exclusive",
    "recurring": true,
    "resource_version": 1517490593188,
    "round_off_amount": 0,
    "status": "not_paid",
    "sub_total": 1000,
    "subscription_id": "__test__8aspTSOcUcz72s",
    "tax": 0,
    "term_finalized": true,
    "total": 1000,
    "updated_at": 1517490593,
    "write_off_amount": 0
  }
}
```

## URL Format

**POST** https://[site].chargebee.com/api/v2/invoices/{invoice-id}/resume_dunning

## Input Parameters

- `comment` (optional, string, max chars=300)
  An internal [comment](/docs/api/comments) to add to the invoice for this operation. This comment is displayed on the Chargebee Billing UI. **Note**: This comment does not appear on any customer-facing [hosted pages](/docs/api/hosted_pages) or documents, such as the [invoice PDF](/docs/api/invoices/retrieve-invoice-as-pdf).

## Returns

- `invoice` (Invoice object)
  Resource object representing invoice
